<template>
  <div class="DateTimePicker">
    <label v-if="label" :for="uuid" class="InputField__Label">
      {{ label }}
    </label>
    <!--suppress HtmlUnknownTag -->
    <v-date-picker
      v-model="date"
      mode="dateTime"
      :locale="locale"
      :masks="masks"
      :isDark="isDark"
      :input-debounce="500"
      :minute-increment="5"
      is24hr
      update-on-input
    >
      <template v-slot="{ inputValue, inputEvents, showPopover, hidePopover }">
        <!--suppress HtmlFormInputWithoutLabel -->
        <input
          :id="uuid"
          :placeholder="placeholder || label"
          class="DateTimePicker__Input"
          :value="inputValue"
          @input="inputEvents.input"
          @change="inputEvents.change"
          @keyup="inputEvents.keyup"
          @focusin="showPopover"
          @focusout="hidePopover"
        />
      </template>
    </v-date-picker>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, getCurrentInstance } from 'vue'
import moment from 'moment'
import { theme } from '@/states'

export default defineComponent({
  name: 'DateTimePicker',
  emits: ['update:modelValue', 'close', 'remove'],
  props: {
    label: String,
    placeholder: String,
    locale: String,
    modelValue: [Date, String],
  },

  setup() {
    return {
      isDark: computed(() => theme.value.includes('Dark')),
      masks: {
        inputDateTime: moment.localeData().longDateFormat('L') + ' HH:mm',
      },
    }
  },

  computed: {
    date: {
      get(): Date {
        if (!this.modelValue) return new Date()
        if (typeof this.modelValue === 'string')
          return new Date(this.modelValue)
        else return this.modelValue
      },
      set(date: Date) {
        this.$emit('update:modelValue', date)
      },
    },

    /**
     * Returns unique identifier of the current instance
     */
    uuid(): number {
      const cid = getCurrentInstance()
      if (cid) return cid.uid
      return -1
    },
  },
})
</script>

<style lang="scss">
@use '../../style/variables' as v;

.DateTimePicker {
  &__Input {
    width: 100%;
    padding: v.$spacing/2 v.$spacing;
    border: none;
    background-color: transparent;
    color: var(--text-color);
  }
}
</style>
